TauP_SetSac (TauP 2.6.1 API)
Description: declaration: package: edu.sc.seis.TauP, class: TauP_SetSac

Package edu.sc.seis.TauP

# Class TauP_SetSac

java.lang.Object
edu.sc.seis.TauP.TauP_Tool
edu.sc.seis.TauP.TauP_Time
edu.sc.seis.TauP.TauP_SetSac

    public class TauP_SetSac
    extends TauP_Time

Calculate times for phases and set sac headers based on gcarc or dist or station lat and lon and event lat and lon. Note that triplicated phases will cause problems, as there is only one spot to put a time. An improved method would allow a phase to have several t#'s associated with it, so that all arrivals could be marked. Currently however, only the first arrival for a phase name is used. Warning: I assume the evdp header has depth in meters unless the -evdpkm flag is set, in which case I assume kilometers. This may be a problem for users that improperly use kilometers for the depth units. Due to much abuse of the sac depth header units I output a warning message if the depth appears to be in kilometers, ie it is less than 1000. This can be safely ignored if the event really is less than 1000 meters deep.

- ## Field Summary

  Fields
  Modifier and Type | Field | Description
  --- | --- | ---
  `static int` | `A_HEADER` |
  `protected boolean` | `evdpkm` |
  `protected java.util.List<java.lang.String>` | `sacFileNames` |

  ### Fields inherited from class edu.sc.seis.TauP.TauP_Time

  `arrivals, azimuth, backAzimuth, degrees, depth, distKilometers, eventLat, eventLon, GUI, modelName, onlyPrintRayP, onlyPrintTime, phaseNames, receiverDepth, relativeArrival, relativePhaseName, stationLat, stationLon, takeoffAngle, tMod, tModDepth`

  ### Fields inherited from class edu.sc.seis.TauP.TauP_Tool

  `DEBUG, expert, GMT, JSON, outFileBase, outForms, outputFormat, SVG, TEXT, toolProps, verbose, writer`

- ## Constructor Summary

  Constructors
  Modifier | Constructor | Description
  --- | --- | ---
  `protected` | `TauP_SetSac()` |
  `` | `TauP_SetSac​(TauModel tMod)` |
  `` | `TauP_SetSac​(java.lang.String modelName)` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `void` | `calculate​(double degrees)` |
  `boolean` | `getEvdpkm()` |
  `void` | `init()` | preforms intialization of the tool.
  `static void` | `main​(java.lang.String[] args)` | Allows TauP_SetSac to run as an application.
  `java.lang.String[]` | `parseCmdLineArgs​(java.lang.String[] args)` |
  `void` | `printStdUsage()` | Prints the command line arguments common to all TauP tools.
  `void` | `printUsage()` |
  `void` | `printUsageTail()` |
  `void` | `processSacFile​(java.io.File f)` |
  `void` | `setEvdpkm​(boolean evdpkm)` |
  `void` | `setSacFileNames​(java.lang.String[] sacFileNames)` |
  `static void` | `setSacTHeader​(edu.sc.seis.seisFile.sac.SacTimeSeries sacFile, int headerNum, Arrival arrival)` |
  `protected void` | `setSacVarNums()` |
  `void` | `start()` |

  ### Methods inherited from class edu.sc.seis.TauP.TauP_Time

  `appendPhaseName, appendPhaseName, calcTakeoff, calcTime, clearArrivals, clearPhaseNames, clearPhases, depthCorrect, depthCorrect, destroy, getArrival, getArrivals, getDisconDepths, getNumArrivals, getNumPhases, getPhaseNames, getPhaseNames, getPhaseNameString, getReceiverDepth, getSeismicPhases, getSourceDepth, getTauModel, getTauModelDepthCorrected, getTauModelName, linearInterp, loadTauModel, parseDegreeList, parsePhaseList, printHelp, printResult, printResultJSON, printResultText, printStdUsageHead, readPhaseFile, readTauModel, recalcPhases, setPhaseNames, setPhaseNames, setReceiverDepth, setSourceDepth, setTauModel, sortArrivals`

  ### Methods inherited from class edu.sc.seis.TauP.TauP_Tool

  `dashEquals, endGmtAndCleanUp, getOutFile, getOutFileBase, getOutFileExtension, getOutputFormat, getWriter, parseCommonCmdLineArgs, printNoComprendoArgs, printScriptBeginning, printStdUsageHead, printStdUsageTail, setOutFileBase, setOutFileExtension, setOutputFormat, setWriter, toolNameFromClass`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### sacFileNames

    protected java.util.List<java.lang.String> sacFileNames

  - ### evdpkm

    protected boolean evdpkm

  - ### A_HEADER

    public static final int A_HEADER
    See Also:
      Constant Field Values

- ## Constructor Details

  - ### TauP_SetSac

    protected TauP_SetSac()

  - ### TauP_SetSac

    public TauP_SetSac​(TauModel tMod) throws TauModelException
    Throws:
      `TauModelException`

  - ### TauP_SetSac

    public TauP_SetSac​(java.lang.String modelName) throws TauModelException
    Throws:
      `TauModelException`

- ## Method Details

  - ### getEvdpkm

    public boolean getEvdpkm()

  - ### setEvdpkm

    public void setEvdpkm​(boolean evdpkm)

  - ### setSacFileNames

    public void setSacFileNames​(java.lang.String[] sacFileNames)

  - ### setSacVarNums

    protected void setSacVarNums()

  - ### calculate

    public void calculate​(double degrees) throws TauModelException
    Overrides:
      `calculate` in class `TauP_Time`
    Throws:
      `TauModelException`

  - ### init

    public void init() throws TauPException
    Description copied from class: `TauP_Time`
    preforms intialization of the tool. Properties are queried for the the default model to load, source depth to use, phases to use, etc. Note that because of the IO inherent in these operations, this method is not appropriate for Applets. Applets should load TauModels themselves and use the setTauModel(TauModel) method.
    Overrides:
      `init` in class `TauP_Time`
    Throws:
      `TauPException`

  - ### start

    public void start() throws java.io.IOException, TauModelException
    Overrides:
      `start` in class `TauP_Time`
    Throws:
      `java.io.IOException`
      `TauModelException`

  - ### processSacFile

    public void processSacFile​(java.io.File f) throws java.io.FileNotFoundException, java.io.IOException, TauModelException
    Throws:
      `java.io.FileNotFoundException`
      `java.io.IOException`
      `TauModelException`

  - ### setSacTHeader

    public static void setSacTHeader​(edu.sc.seis.seisFile.sac.SacTimeSeries sacFile, int headerNum, Arrival arrival)

  - ### printStdUsage

    public void printStdUsage()
    Description copied from class: `TauP_Time`
    Prints the command line arguments common to all TauP tools.
    Overrides:
      `printStdUsage` in class `TauP_Time`

  - ### printUsageTail

    public void printUsageTail()

  - ### printUsage

    public void printUsage()
    Overrides:
      `printUsage` in class `TauP_Time`

  - ### parseCmdLineArgs

    public java.lang.String[] parseCmdLineArgs​(java.lang.String[] args) throws java.io.IOException
    Overrides:
      `parseCmdLineArgs` in class `TauP_Time`
    Throws:
      `java.io.IOException`

  - ### main

    public static void main​(java.lang.String[] args) throws java.io.IOException
    Allows TauP_SetSac to run as an application. Creates an instance of TauP_SetSac. ToolRun.main should be used instead.
    Throws:
      `java.io.IOException`